VERSION 5.00
Begin VB.Form MainForm 
   AutoRedraw      =   -1  'True
   Caption         =   "MainForm"
   ClientHeight    =   4530
   ClientLeft      =   60
   ClientTop       =   750
   ClientWidth     =   9765
   LinkTopic       =   "Form1"
   ScaleHeight     =   4530
   ScaleWidth      =   9765
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame HiSpeedDeviceTypeFrame 
      Caption         =   "Hi Speed Device Type"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   615
      Left            =   360
      TabIndex        =   5
      Top             =   1800
      Width           =   2775
      Begin VB.OptionButton FT4232HRadioButton 
         Caption         =   "FT4232H"
         Enabled         =   0   'False
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   1440
         TabIndex        =   8
         Top             =   240
         Width           =   1215
      End
      Begin VB.OptionButton FT2232HRadioButton 
         Caption         =   "FT2232H"
         Enabled         =   0   'False
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   120
         TabIndex        =   6
         Top             =   240
         Width           =   1215
      End
   End
   Begin VB.ComboBox ChannelComboBox 
      Height          =   315
      Left            =   8640
      TabIndex        =   3
      Top             =   600
      Width           =   615
   End
   Begin VB.CommandButton TestCommand 
      Caption         =   "Test"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   8160
      TabIndex        =   0
      Top             =   3120
      Width           =   1095
   End
   Begin VB.Label ChannelLabel 
      Caption         =   "Channel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   7800
      TabIndex        =   7
      Top             =   720
      Width           =   735
   End
   Begin VB.Label DeviceNameLabel 
      Caption         =   "Device Name = "
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   360
      TabIndex        =   4
      Top             =   1200
      Width           =   3015
   End
   Begin VB.Label PassFailLabel 
      Caption         =   "Pass/Failure = "
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   360
      TabIndex        =   2
      Top             =   4080
      Width           =   7935
   End
   Begin VB.Label DLLVersionLabel 
      Caption         =   "FT2232/FT4232 JTAG DLL Version = "
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   360
      TabIndex        =   1
      Top             =   600
      Width           =   3735
   End
   Begin VB.Menu menuOptions 
      Caption         =   "&Options"
      Index           =   1
      Begin VB.Menu menuCmdSeq 
         Caption         =   "&Cmd Seq"
         Checked         =   -1  'True
      End
      Begin VB.Menu sep1 
         Caption         =   "-"
      End
      Begin VB.Menu menuExit 
         Caption         =   "&Exit"
      End
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Copyright (c) 2008  Future Technology Devices International Ltd.
'
' Module Name
'
'     MainForm.frm
'
' Abstract:
'
'    Visual Basic program, to test the FTCJTAG.DLL. The FTCJTAG.DLL is used to control the FT2232H dual hi-speed device
'    and the FT4232H quad hi-speed device to simulate the Joint Test Action Group(JTAG) synchronous protocol to
'    communicate with JTAG devices connected to FT2232H dual hi-speed devices and FT4232H quad hi-speed devices.
'
' Revision History:
'
'   28/07/08    Kirke Ashton    Created.
'
Private Type FTC_INPUT_OUTPUT_PINS
    bPin1InputOutputState As Long 'Boolean
    bPin1LowHighState As Long 'Boolean
    bPin2InputOutputState As Long 'Boolean
    bPin2LowHighState As Long 'Boolean
    bPin3InputOutputState As Long 'Boolean
    bPin3LowHighState As Long 'Boolean
    bPin4InputOutputState As Long 'Boolean
    bPin4LowHighState As Long 'Boolean
End Type

Private Type FTH_INPUT_OUTPUT_PINS
    bPin1InputOutputState As Long 'Boolean
    bPin1LowHighState As Long 'Boolean
    bPin2InputOutputState As Long 'Boolean
    bPin2LowHighState As Long 'Boolean
    bPin3InputOutputState As Long 'Boolean
    bPin3LowHighState As Long 'Boolean
    bPin4InputOutputState As Long 'Boolean
    bPin4LowHighState As Long 'Boolean
    bPin5InputOutputState As Long 'Boolean
    bPin5LowHighState As Long 'Boolean
    bPin6InputOutputState As Long 'Boolean
    bPin6LowHighState As Long 'Boolean
    bPin7InputOutputState As Long 'Boolean
    bPin7LowHighState As Long 'Boolean
    bPin8InputOutputState As Long 'Boolean
    bPin8LowHighState As Long 'Boolean
End Type

Private Type FTC_LOW_HIGH_PINS
    bPin1LowHighState As Long 'Boolean
    bPin2LowHighState As Long 'Boolean
    bPin3LowHighState As Long 'Boolean
    bPin4LowHighState As Long 'Boolean
End Type

Private Type FTH_LOW_HIGH_PINS
    bPin1LowHighState As Long 'Boolean
    bPin2LowHighState As Long 'Boolean
    bPin3LowHighState As Long 'Boolean
    bPin4LowHighState As Long 'Boolean
    bPin5LowHighState As Long 'Boolean
    bPin6LowHighState As Long 'Boolean
    bPin7LowHighState As Long 'Boolean
    bPin8LowHighState As Long 'Boolean
End Type

Private Type FTC_CLOSE_FINAL_STATE_PINS
    bTCKPinState As Long 'Boolean
    bTCKPinActiveState As Long 'Boolean
    bTDIPinState As Long 'Boolean
    bTDIPinActiveState As Long 'Boolean
    bTMSPinState As Long 'Boolean
    bTMSPinActiveState As Long 'Boolean
End Type

Private Declare Function JTAG_GetNumHiSpeedDevices Lib "ftcjtag" (ByRef NumHiSpeedDevices As Long) As Long
Private Declare Function JTAG_GetHiSpeedDeviceNameLocIDChannel Lib "ftcjtag" (ByVal DeviceNameIndex As Long, ByVal DeviceName As String, ByVal DeviceNameBufferSize As Long, ByRef lpLocationID As Long, ByVal Channel As String, ByVal ChannelBufferSize As Long, ByRef lpHiSpeedDeviceType As Long) As Long
Private Declare Function JTAG_OpenHiSpeedDevice Lib "ftcjtag" (ByVal DeviceName As String, ByVal LocationID As Long, ByVal Channel As String, ByRef ftHandle As Long) As Long
Private Declare Function JTAG_GetHiSpeedDeviceType Lib "ftcjtag" (ByVal ftHandle As Long, ByRef lpHiSpeedDeviceType As Long) As Long
Private Declare Function JTAG_Close Lib "ftcjtag" (ByVal ftHandle As Long) As Long
Private Declare Function JTAG_CloseDevice Lib "ftcjtag" (ByVal ftHandle As Long, ByRef pCloseFinalStatePinsData As FTC_CLOSE_FINAL_STATE_PINS) As Long
Private Declare Function JTAG_InitDevice Lib "ftcjtag" (ByVal ftHandle As Long, ByVal ClockDivisor As Long) As Long
Private Declare Function JTAG_TurnOnDivideByFiveClockingHiSpeedDevice Lib "ftcjtag" (ByVal ftHandle As Long) As Long
Private Declare Function JTAG_TurnOffDivideByFiveClockingHiSpeedDevice Lib "ftcjtag" (ByVal ftHandle As Long) As Long
Private Declare Function JTAG_TurnOnAdaptiveClockingHiSpeedDevice Lib "ftcjtag" (ByVal ftHandle As Long) As Long
Private Declare Function JTAG_TurnOffAdaptiveClockingHiSpeedDevice Lib "ftcjtag" (ByVal ftHandle As Long) As Long
Private Declare Function JTAG_SetDeviceLatencyTimer Lib "ftcjtag" (ByVal ftHandle As Long, ByVal TimerValue As Byte) As Long
Private Declare Function JTAG_GetDeviceLatencyTimer Lib "ftcjtag" (ByVal ftHandle As Long, ByRef lpTimerValue As Byte) As Long
Private Declare Function JTAG_GetHiSpeedDeviceClock Lib "ftcjtag" (ByVal ClockDivisor As Long, ByRef lpClockFrequencyHz As Long) As Long
Private Declare Function JTAG_GetClock Lib "ftcjtag" (ByVal ClockDivisor As Long, ByRef lpClockFrequencyHz As Long) As Long
Private Declare Function JTAG_SetClock Lib "ftcjtag" (ByVal ftHandle As Long, ByVal ClockDivisor As Long, ByRef lpClockFrequencyHz As Long) As Long
Private Declare Function JTAG_SetLoopback Lib "ftcjtag" (ByVal ftHandle As Long, ByVal bLoopbackState As Boolean) As Long
Private Declare Function JTAG_SetGPIOs Lib "ftcjtag" (ByVal ftHandle As Long, ByVal bControlLowInputOutputPins As Boolean, ByRef pLowInputOutputPinsData As FTC_INPUT_OUTPUT_PINS, ByVal bControlHighInputOutputPins As Boolean, ByRef pHighInputOutputPinsData As FTC_INPUT_OUTPUT_PINS) As Long
Private Declare Function JTAG_SetHiSpeedDeviceGPIOs Lib "ftcjtag" (ByVal ftHandle As Long, ByVal bControlLowInputOutputPins As Boolean, ByRef pLowInputOutputPinsData As FTC_INPUT_OUTPUT_PINS, ByVal bControlHighInputOutputPins As Boolean, ByRef pHighInputOutputPinsData As FTH_INPUT_OUTPUT_PINS) As Long
Private Declare Function JTAG_GetGPIOs Lib "ftcjtag" (ByVal ftHandle As Long, ByVal bControlLowInputOutputPins As Boolean, ByRef pLowPinsInputData As FTC_LOW_HIGH_PINS, ByVal bControlHighInputOutputPins As Boolean, ByRef pHighPinsInputData As FTC_LOW_HIGH_PINS) As Long
Private Declare Function JTAG_GetHiSpeedDeviceGPIOs Lib "ftcjtag" (ByVal ftHandle As Long, ByVal bControlLowInputOutputPins As Boolean, ByRef pLowPinsInputData As FTC_LOW_HIGH_PINS, ByVal bControlHighInputOutputPins As Boolean, ByRef pHighPinsInputData As FTH_LOW_HIGH_PINS) As Long
Private Declare Function JTAG_Write Lib "ftcjtag" (ByVal ftHandle As Long, ByVal bInstructionTestData As Boolean, ByVal NumBitsToWrite As Long, WriteDataBuffer As Any, ByVal NumBytesToWrite As Long, ByVal TapControllerState As Long) As Long
Private Declare Function JTAG_Read Lib "ftcjtag" (ByVal ftHandle As Long, ByVal bInstructionTestData As Boolean, ByVal NumBitsToRead As Long, ReadDataBuffer As Any, ByRef lpNumBytesReturned As Long, ByVal TapControllerState As Long) As Long
Private Declare Function JTAG_WriteRead Lib "ftcjtag" (ByVal ftHandle As Long, ByVal bInstructionTestData As Boolean, ByVal NumBitsToWriteRead As Long, WriteDataBuffer As Any, ByVal NumBytesToWrite As Long, ReadDataBuffer As Any, ByRef lpNumBytesReturned As Long, ByVal TapControllerState As Long) As Long
Private Declare Function JTAG_ClearCmdSequence Lib "ftcjtag" () As Long
Private Declare Function JTAG_AddWriteCmd Lib "ftcjtag" (ByVal bInstructionTestData As Boolean, ByVal NumBitsToWrite As Long, WriteDataBuffer As Any, ByVal NumBytesToWrite As Long, ByVal TapControllerState As Long) As Long
Private Declare Function JTAG_AddReadCmd Lib "ftcjtag" (ByVal bInstructionTestData As Boolean, ByVal NumBitsToRead As Long, ByVal TapControllerState As Long) As Long
Private Declare Function JTAG_AddWriteReadCmd Lib "ftcjtag" (ByVal bInstructionTestData As Boolean, ByVal NumBitsToWriteRead As Long, WriteDataBuffer As Any, ByVal NumBytesToWrite As Long, ByVal TapControllerState As Long) As Long
Private Declare Function JTAG_ClearDeviceCmdSequence Lib "ftcjtag" (ByVal ftHandle As Long) As Long
Private Declare Function JTAG_AddDeviceWriteCmd Lib "ftcjtag" (ByVal ftHandle As Long, ByVal bInstructionTestData As Boolean, ByVal NumBitsToWrite As Long, WriteDataBuffer As Any, ByVal NumBytesToWrite As Long, ByVal TapControllerState As Long) As Long
Private Declare Function JTAG_AddDeviceReadCmd Lib "ftcjtag" (ByVal ftHandle As Long, ByVal bInstructionTestData As Boolean, ByVal NumBitsToRead As Long, ByVal TapControllerState As Long) As Long
Private Declare Function JTAG_AddDeviceWriteReadCmd Lib "ftcjtag" (ByVal ftHandle As Long, ByVal bInstructionTestData As Boolean, ByVal NumBitsToWriteRead As Long, WriteDataBuffer As Any, ByVal NumBytesToWrite As Long, ByVal TapControllerState As Long) As Long
Private Declare Function JTAG_ExecuteCmdSequence Lib "ftcjtag" (ByVal ftHandle As Long, ReadCmdSequenceDataBuffer As Any, ByRef lpNumBytesReturned As Long) As Long
Private Declare Function JTAG_GetDllVersion Lib "ftcjtag" (ByVal DllVersion As String, ByVal BufferSize As Long) As Long
Private Declare Function JTAG_GetErrorCodeString Lib "ftcjtag" (ByVal Language As String, ByVal StatusCode As Long, ByVal ErrorMessage As String, ByVal BufferSize As Long) As Long

Private Declare Function Sleep Lib "Kernel32" (ByVal Milliseconds As Integer) As Long

Private Const FTC_SUCCESS = 0

Private Const TEST_LOGIC_STATE = 1
Private Const RUN_TEST_IDLE_STATE = 2
Private Const PAUSE_TEST_DATA_REGISTER_STATE = 3
Private Const PAUSE_INSTRUCTION_REGISTER_STATE = 4
Private Const SHIFT_TEST_DATA_REGISTER_STATE = 5
Private Const SHIFT_INSTRUCTION_REGISTER_STATE = 6

Private Const WRITE_DATA_BUFFER_SIZE = 65536
Private Const READ_DATA_BUFFER_SIZE = 65536
Private Const READ_CMDS_DATA_BUFFER_SIZE = 131071

Private Const MAX_NUM_DEVICE_NAME_CHARS = 100
Private Const MAX_NUM_CHANNEL_CHARS = 5

Private Const MAX_NUM_DLL_VERSION_CHARS = 10
    
Private Const MAX_NUM_ERROR_MESSAGE_CHARS = 100

Private Enum hiSpeedDeviceTypes
    FT2232H_Device_Type = 1
    FT4232H_Device_Type = 2
End Enum

'Private Const FT2232H_Device_Type = 1
'Private Const FT4232H_Device_Type = 2
    
Private Const App_Title = "FT2232/FT4232 Hi-Speed JTAG Device Visual Basic V6.0 Test Application"

Private Const Default_Dll_Version_Caption = "FT2232/FT4232 JTAG DLL Version = "

Private Const Device_Name_Label = "Device Name = "

Private Const Pass_Fail_Label = "Pass/Failure = "
    
Private ftHandle As Long


Private Sub Form_Load()

    MainForm.Caption = App_Title
    
    Me.menuCmdSeq.Checked = False
    
    Me.ChannelComboBox.List(0) = "A"
    Me.ChannelComboBox.List(1) = "B"
    'Me.ChannelComboBox.Text = "A"
    Me.ChannelComboBox.ListIndex = 0 '-1
    
    ftHandle = 0
End Sub
Private Sub Form_Unload(Cancel As Integer)
        Dim ftStatus As Long
        
        ftStatus = DS_SUCCESS

        If (ftHandle <> 0) Then
            ftStatus = JTAG_Close(ftHandle)
        End If
End Sub
Private Function ConvertDLLStringToVBString(ByRef DLLString As String) As String
    Dim VBString As String
    Dim DllCharCntr As Long
    Dim VBCharCntr As Long
    Dim DLLStrCharArray() As Byte
    Dim VBStrCharArray() As Byte
        
    DllCharCntr = 0

    DLLStrCharArray = StrConv(DLLString, vbFromUnicode)   ' Convert string.

    While (DLLStrCharArray(DllCharCntr) <> 0)
        DllCharCntr = DllCharCntr + 1
    Wend
        
    ReDim VBStrCharArray(0 To (DllCharCntr - 1)) As Byte
    For VBCharCntr = 0 To (DllCharCntr - 1)
        VBStrCharArray(VBCharCntr) = DLLStrCharArray(VBCharCntr)
    Next

    ConvertDLLStringToVBString = StrConv(VBStrCharArray, vbUnicode)
End Function

Private Function TestHiSpeedDeviceClock(ByVal ftHandle As Long) As Long
    Dim ftStatus As Long
    Dim ClockFrequencyHz As Long
        
    ftStatus = FTC_SUCCESS
    ClockFrequencyHz = 0

    ftStatus = JTAG_GetHiSpeedDeviceClock(0, ClockFrequencyHz)

    If (ftStatus = FTC_SUCCESS) Then
        ftStatus = JTAG_TurnOnDivideByFiveClockingHiSpeedDevice(ftHandle)

        If (ftStatus = FTC_SUCCESS) Then
            ftStatus = JTAG_GetHiSpeedDeviceClock(0, ClockFrequencyHz)

            ftStatus = JTAG_SetClock(ftHandle, 0, ClockFrequencyHz)

            If (ftStatus = FTC_SUCCESS) Then
                ftStatus = JTAG_TurnOffDivideByFiveClockingHiSpeedDevice(ftHandle)

                ftStatus = JTAG_SetClock(ftHandle, 1, ClockFrequencyHz)
            End If
        End If
    End If

    TestHiSpeedDeviceClock = ftStatus
End Function


Private Sub menuCmdSeq_Click()
    menuCmdSeq.Checked = Not menuCmdSeq.Checked
End Sub

Private Sub menuExit_Click()
    Unload Me
End Sub

Private Sub TestCommand_Click()
    Dim ftStatus As Long
    Dim NumHiSpeedDevices As Long
    Dim HiSpeedDeviceType As Long
    Dim HiSpeedDeviceIndex As Long
    Dim HiSpeedDeviceName As String
    Dim HiSpeedDeviceChannel As String
    Dim HSDN As String
    Dim HSCH As String
    Dim LocationID As Long
    Dim ClockFrequencyHz As Long
    Dim bLoopbackState As Boolean
    Dim LowInputOutputPinsData As FTC_INPUT_OUTPUT_PINS
    Dim HighInputOutputPinsData As FTH_INPUT_OUTPUT_PINS
    Dim LowPinsInputData As FTC_LOW_HIGH_PINS
    Dim HighPinsInputData As FTH_LOW_HIGH_PINS
    Dim CloseFinalStatePinsData As FTC_CLOSE_FINAL_STATE_PINS
    Dim WriteDataBuffer((WRITE_DATA_BUFFER_SIZE - 1)) As Byte
    Dim ReadDataBuffer((READ_DATA_BUFFER_SIZE - 1)) As Byte
    Dim ReadCmdSequenceDataBuffer((READ_CMDS_DATA_BUFFER_SIZE - 1)) As Byte
    Dim NumBytesReturned As Long
    Dim iLoopCntr As Integer
    Dim mismatchMsg, Style, Title, Response As String
    Dim StatusErrorMessage As String
    Dim ErrorMessage As String
    Dim DllVersion As String
        
    ftStatus = FTC_SUCCESS
    NumHiSpeedDevices = 0
    HiSpeedDeviceIndex = 0
    HiSpeedDeviceName = String$(MAX_NUM_DEVICE_NAME_CHARS, Chr(0))
    HiSpeedDeviceChannel = String$(MAX_NUM_CHANNEL_CHARS, Chr(0))
    LocationID = 0
    ClockFrequencyHz = 0
    bLoopbackState = False
    NumBytesReturned = 0
    iLoopCntr = 0
    mismatchMsg = vbNullString
    Response = vbOK
    bPerformCommandSequence = False
    
    StatusErrorMessage = String$(MAX_NUM_ERROR_MESSAGE_CHARS, ChrW(0))
    
    DeviceNameLabel.Caption = Device_Name_Label
    DeviceNameLabel.Refresh
    
    Me.FT2232HRadioButton.Value = False
    FT4232HRadioButton.Value = False
    
    PassFailLabel.Caption = Pass_Fail_Label
    PassFailLabel.Refresh
    
    DllVersion = String$(MAX_NUM_DLL_VERSION_CHARS, ChrW(0))
    ftStatus = JTAG_GetDllVersion(DllVersion, MAX_NUM_DLL_VERSION_CHARS)
    DLLVersionLabel.Caption = Default_Dll_Version_Caption + DllVersion
    DLLVersionLabel.Refresh
    'MsgBox (DllVersion)

    ftStatus = JTAG_GetNumHiSpeedDevices(NumHiSpeedDevices)

    If ((ftStatus = FTC_SUCCESS) And (NumHiSpeedDevices > 0)) Then
        If ((Me.ChannelComboBox.ListIndex = 0) Or (Me.ChannelComboBox.ListIndex = 1)) Then
            Do
                ftStatus = JTAG_GetHiSpeedDeviceNameLocIDChannel(HiSpeedDeviceIndex, HiSpeedDeviceName, MAX_NUM_DEVICE_NAME_CHARS, LocationID, HiSpeedDeviceChannel, MAX_NUM_CHANNEL_CHARS, HiSpeedDeviceType)
                   
                If (ftStatus = FTC_SUCCESS) Then
                    HSCH = ConvertDLLStringToVBString(HiSpeedDeviceChannel)
                End If
            
                HiSpeedDeviceIndex = HiSpeedDeviceIndex + 1
            Loop While ((ftStatus = FTC_SUCCESS) And (HiSpeedDeviceIndex < NumHiSpeedDevices) And ((HSCH <> vbNullString) And (HSCH <> Me.ChannelComboBox.Text)))
        End If
        
        If (ftStatus = FTC_SUCCESS) Then
            HSDN = ConvertDLLStringToVBString(HiSpeedDeviceName)
            
            ftStatus = JTAG_OpenHiSpeedDevice(HSDN, LocationID, HSCH, ftHandle)
            
            Me.DeviceNameLabel.Caption = Device_Name_Label + HSDN
            Me.DeviceNameLabel.Refresh
            
            If (ftStatus = FTC_SUCCESS) Then
                ftStatus = JTAG_GetHiSpeedDeviceType(ftHandle, HiSpeedDeviceType)

                If (ftStatus = FTC_SUCCESS) Then
                    If (HiSpeedDeviceType = hiSpeedDeviceTypes.FT4232H_Device_Type) Then
                        FT4232HRadioButton.Value = True
                    ElseIf (HiSpeedDeviceType = hiSpeedDeviceTypes.FT2232H_Device_Type) Then
                        Me.FT2232HRadioButton.Value = True
                    End If
                End If
            End If
        End If
        
        If ((ftHandle <> 0) And (ftStatus = FTC_SUCCESS)) Then
            ftStatus = JTAG_InitDevice(ftHandle, 0)

            If (ftStatus = FTC_SUCCESS) Then
                'ftStatus = JTAG_TurnOnAdaptiveClockingHiSpeedDevice(ftHandle)

                'ftStatus = JTAG_TurnOffAdaptiveClockingHiSpeedDevice(ftHandle)
            End If

            If (ftStatus = FTC_SUCCESS) Then
                ftStatus = JTAG_GetDeviceLatencyTimer(ftHandle, TimerValue)

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = JTAG_SetDeviceLatencyTimer(ftHandle, 50)

                    If (ftStatus = FTC_SUCCESS) Then
                        ftStatus = JTAG_GetDeviceLatencyTimer(ftHandle, TimerValue)

                        ftStatus = JTAG_SetDeviceLatencyTimer(ftHandle, 16)

                        ftStatus = JTAG_GetDeviceLatencyTimer(ftHandle, TimerValue)
                    End If
                End If
            End If
            
            If (ftStatus = FTC_SUCCESS) Then
                ftStatus = TestHiSpeedDeviceClock(ftHandle)
            End If
            
            If (ftStatus = FTC_SUCCESS) Then
                ftStatus = JTAG_SetLoopback(ftHandle, False)
            End If

            If (ftStatus = FTC_SUCCESS) Then
                LowInputOutputPinsData.bPin1InputOutputState = True
                LowInputOutputPinsData.bPin2InputOutputState = True
                LowInputOutputPinsData.bPin3InputOutputState = True
                LowInputOutputPinsData.bPin4InputOutputState = True
                LowInputOutputPinsData.bPin1LowHighState = True
                LowInputOutputPinsData.bPin2LowHighState = False
                LowInputOutputPinsData.bPin3LowHighState = True
                LowInputOutputPinsData.bPin4LowHighState = True

                If (HiSpeedDeviceType = FT2232H_Device_Type) Then
                    HighInputOutputPinsData.bPin1InputOutputState = True
                    HighInputOutputPinsData.bPin2InputOutputState = True
                    HighInputOutputPinsData.bPin3InputOutputState = True
                    HighInputOutputPinsData.bPin4InputOutputState = True
                    HighInputOutputPinsData.bPin5InputOutputState = True
                    HighInputOutputPinsData.bPin6InputOutputState = True
                    HighInputOutputPinsData.bPin7InputOutputState = True
                    HighInputOutputPinsData.bPin8InputOutputState = True
                    HighInputOutputPinsData.bPin1LowHighState = True
                    HighInputOutputPinsData.bPin2LowHighState = False
                    HighInputOutputPinsData.bPin3LowHighState = False
                    HighInputOutputPinsData.bPin4LowHighState = True
                    HighInputOutputPinsData.bPin5LowHighState = True
                    HighInputOutputPinsData.bPin6LowHighState = False
                    HighInputOutputPinsData.bPin7LowHighState = False
                    HighInputOutputPinsData.bPin8LowHighState = True

                    ftStatus = JTAG_SetHiSpeedDeviceGPIOs(ftHandle, True, LowInputOutputPinsData, True, HighInputOutputPinsData)
                Else
                    ftStatus = JTAG_SetHiSpeedDeviceGPIOs(ftHandle, True, LowInputOutputPinsData, False, HighInputOutputPinsData)
                End If

                If (ftStatus = FTC_SUCCESS) Then
                    If (HiSpeedDeviceType = FT2232H_Device_Type) Then
                        ftStatus = JTAG_GetHiSpeedDeviceGPIOs(ftHandle, True, LowPinsInputData, True, HighPinsInputData)
                    Else
                        ftStatus = JTAG_GetHiSpeedDeviceGPIOs(ftHandle, True, LowPinsInputData, False, HighPinsInputData)
                    End If
                End If
                
                If (ftStatus = FTC_SUCCESS) Then
                    WriteDataBuffer(0) = &H1
                    WriteDataBuffer(1) = &H1
                    WriteDataBuffer(2) = &H1
                    WriteDataBuffer(3) = &H1

                    If (menuCmdSeq.Checked = False) Then
                        Style = vbOKCancel + vbCritical   ' Define buttons.
                        Title = "I2C Read Error Message"   ' Define title.

                        Do
                            ftStatus = JTAG_Write(ftHandle, True, 32, WriteDataBuffer(0), 4, RUN_TEST_IDLE_STATE)

                            If (ftStatus = FTC_SUCCESS) Then
                                Sleep (10)

                                ftStatus = JTAG_Read(ftHandle, True, 32, ReadDataBuffer(0), NumBytesReturned, RUN_TEST_IDLE_STATE)

                                If (ftStatus = FTC_SUCCESS) Then
                                    Sleep (10)
                                
                                    ftStatus = JTAG_WriteRead(ftHandle, True, 32, WriteDataBuffer(0), 4, ReadDataBuffer(0), NumBytesReturned, RUN_TEST_IDLE_STATE)
                                    
                                    If (ftStatus = FTC_SUCCESS) Then
                                        If ((WriteDataBuffer(0) <> ReadDataBuffer(0)) Or (WriteDataBuffer(1) <> ReadDataBuffer(1)) Or (WriteDataBuffer(2) <> ReadDataBuffer(2)) Or (WriteDataBuffer(3) <> ReadDataBuffer(3))) Then
                                            Dim mismatchValue As Byte
                                            mismatchValue = 0

                                            If (WriteDataBuffer(0) <> ReadDataBuffer(0)) Then
                                                mismatchValue = ReadDataBuffer(0)
                                            ElseIf (WriteDataBuffer(1) <> ReadDataBuffer(1)) Then
                                                mismatchValue = ReadDataBuffer(1)
                                            ElseIf (WriteDataBuffer(2) <> ReadDataBuffer(2)) Then
                                                mismatchValue = ReadDataBuffer(2)
                                            ElseIf (WriteDataBuffer(3) <> ReadDataBuffer(3)) Then
                                                mismatchValue = ReadDataBuffer(3)
                                            End If
                                            
                                            mismatchMsg = "JTAG Write/Read mismatch, Loop = " + Format(iLoopCntr) + ", Write Value = " + Format(1) + ", Read Value = " + Format(mismatchValue)

                                            Response = MsgBox(mismatchMsg, Style, Title)
                                        End If
                                    End If
                                End If
                            End If
                            
                            iLoopCntr = iLoopCntr + 1
                            
                            Sleep (50)
                        Loop While ((iLoopCntr < 20) And (ftStatus = FTC_SUCCESS) And (Response = vbOK))
                    Else
                        If (NumDevices = 1) Then
                            ftStatus = JTAG_ClearCmdSequence()

                            Do
                                ftStatus = JTAG_AddWriteCmd(True, 32, WriteDataBuffer(0), 4, RUN_TEST_IDLE_STATE)

                                If (ftStatus = FTC_SUCCESS) Then
                                    ftStatus = JTAG_AddReadCmd(True, 32, RUN_TEST_IDLE_STATE)
                                End If

                                If (ftStatus = FTC_SUCCESS) Then
                                    ftStatus = JTAG_AddWriteReadCmd(True, 32, WriteDataBuffer(0), 4, RUN_TEST_IDLE_STATE)
                                End If

                                iLoopCntr = iLoopCntr + 1
                            Loop While ((iLoopCntr < 5) And (ftStatus = FTC_SUCCESS))
                        
                        Else
                            ftStatus = JTAG_ClearDeviceCmdSequence(ftHandle)

                            Do
                                ftStatus = JTAG_AddDeviceWriteCmd(ftHandle, True, 32, WriteDataBuffer(0), 4, RUN_TEST_IDLE_STATE)

                                If (ftStatus = FTC_SUCCESS) Then
                                    ftStatus = JTAG_AddDeviceReadCmd(ftHandle, True, 32, RUN_TEST_IDLE_STATE)
                                End If

                                If (ftStatus = FTC_SUCCESS) Then
                                    ftStatus = JTAG_AddDeviceWriteReadCmd(ftHandle, True, 32, WriteDataBuffer(0), 4, RUN_TEST_IDLE_STATE)
                                End If

                                iLoopCntr = iLoopCntr + 1
                            Loop While ((iLoopCntr < 5) And (ftStatus = FTC_SUCCESS))
                        End If
                        
                        If (ftStatus = FTC_SUCCESS) Then
                             ftStatus = JTAG_ExecuteCmdSequence(ftHandle, ReadCmdSequenceDataBuffer(0), NumBytesReturned)
                        End If
                    End If
                End If
            End If
        End If
        
        If (ftHandle <> 0) Then
            'CloseFinalStatePinsData.bTCKPinState = True
            'CloseFinalStatePinsData.bTCKPinActiveState = True
            'CloseFinalStatePinsData.bTDIPinState = True
            'CloseFinalStatePinsData.bTDIPinActiveState = False
            'CloseFinalStatePinsData.bTMSPinState = True
            'CloseFinalStatePinsData.bTMSPinActiveState = True
            
            'ftStatus = JTAG_CloseDevice(ftHandle, CloseFinalStatePinsData)
            
            JTAG_Close (ftHandle)
            ftHandle = 0
        End If
    End If

    If ((ftStatus <> FTC_SUCCESS) Or (NumHiSpeedDevices = 0) Or (mismatchMsg <> vbNullString)) Then
        If (ftStatus <> FTC_SUCCESS) Then
            ErrorMessage = "Status Code(" + Format(ftStatus) + ") - "

            ftStatus = JTAG_GetErrorCodeString("EN", ftStatus, StatusErrorMessage, MAX_NUM_ERROR_MESSAGE_CHARS)
            
            ErrorMessage = ErrorMessage + StatusErrorMessage

            MsgBox (ErrorMessage)
        Else
            If (NumHiSpeedDevices = 0) Then
                ErrorMessage = "There are no devices connected."

                MsgBox (ErrorMessage)
            Else
                ErrorMessage = mismatchMsg
            End If
        End If
       
        PassFailLabel.Caption = Pass_Fail_Label + "Fail - " + ErrorMessage

        'MsgBox (ErrorMessage)
    Else
        PassFailLabel.Caption = Pass_Fail_Label + "Pass"
    End If
    
    PassFailLabel.Refresh
End Sub
